package org.openmuc.jdlms.internal;

public enum ReleaseReqReason {
    NORMAL(0),
    URGENT(1),
    USER_DEFINED(2),
    UNKNOWN(-1);

    private static final ReleaseReqReason[] VALUES = values();
    private long code;

    private ReleaseReqReason(long code) {
        this.code = code;
    }

    public static ReleaseReqReason reasonFor(long code) {
        for (ReleaseReqReason reason : VALUES) {
            if (reason.code == code) {
                return reason;
            }
        }

        return UNKNOWN;
    }

    public long getCode() {
        return code;
    }
}
